
import java.io.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class EssayLoader {
	private static final int nQ = 20;
	private String[] quest = new String[nQ];
	private String[] a = new String[nQ];
	private String[] b = new String[nQ];
	private String[] c = new String[nQ];
	private String[] d = new String[nQ];
	private String[] e = new String[nQ];
	private String[] right = new String[nQ];
	
	public EssayLoader() throws Exception{
		//The two lines below are just for getting an
        //instance of DocumentBuilder which we use
        //for parsing XML data
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();

        //Here we do the actual parsing
        Document doc = builder.parse(new File("essay.xml"));

        //Here we get the root element of XML and print out
        //the value of its 'testAttr' attribute
        Element rootElement = doc.getDocumentElement();

        //Here we get a list of all elements named 'child'
        NodeList list = rootElement.getElementsByTagName("q");

        //Traversing all the elements from the list and printing
        //out its data
        for (int i = 0; i < nQ; i++) {
            //Getting one node from the list.
            //BTW, we used method getElementsByTagName so every entry
            //in the list is effectively of type 'Element', so you could
            //cast it directly to 'Element' if you needed to.
            Node qNode = list.item(i);
            NodeList alternatives = qNode.getChildNodes();
            for(int j = 0; j < alternatives.getLength(); j++){
            	Node aux = alternatives.item(j);
            	if(aux.getNodeType()==Node.ELEMENT_NODE){
            		Element el = (Element) aux;
            		if(el.getTagName().equalsIgnoreCase("text")){
            			quest[i]=el.getTextContent();
            		} else if(el.getTagName().equalsIgnoreCase("a")){
            			a[i]=el.getTextContent();
            		} else if(el.getTagName().equalsIgnoreCase("b")){
            			b[i]=el.getTextContent();
            		} else if(el.getTagName().equalsIgnoreCase("c")){
            			c[i]=el.getTextContent();
            		} else if(el.getTagName().equalsIgnoreCase("d")){
            			d[i]=el.getTextContent();
            		} else if(el.getTagName().equalsIgnoreCase("e")){
            			e[i]=el.getTextContent();
            		} else if(el.getTagName().equalsIgnoreCase("right")){
            			right[i]=el.getTextContent();
            		}
            	}
            }
        }
	}
	public String getQuest(int i){
		return quest[i];
	}
	public String getA(int i){
		return a[i];
	}
	public String getB(int i){
		return b[i];
	}
	public String getC(int i){
		return c[i];
	}
	public String getD(int i){
		return d[i];
	}
	public String getE(int i){
		return e[i];
	}
	public String getRight(int i){
		return right[i];
	}
}

