
import java.text.NumberFormat;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.CategoryAxis;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.labels.StandardCategoryItemLabelGenerator;
import org.jfree.chart.labels.StandardCategoryToolTipGenerator;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.CombinedDomainCategoryPlot;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;



public class PanelHistorico extends JTabbedPane{

	private static final long serialVersionUID = 1L;

	public PanelHistorico(userHandler u) throws Exception {
		super();
		PanelPreguntas panel = new PanelPreguntas(u);
		PanelPuntajes panelpuntajes = new PanelPuntajes(u);
		addTab("Puntajes", panelpuntajes);
		addTab("Respuestas", panel);
	}
}

class PanelPreguntas extends JPanel {
	private static final long serialVersionUID = 1L;
	public PanelPreguntas(userHandler u) throws Exception {
		JLabel jLabel1 = new JLabel();
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/header2.png")));
		final CategoryDataset dataset = createDataset(u);
		final JFreeChart chart = createChart(dataset,u);
		final ChartPanel chartPanel = new ChartPanel(chart);
		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS)); //BoxLayout permite resize del panel
		add(jLabel1);
		add(chartPanel);
	}

	private CategoryDataset createDataset(userHandler u) throws Exception {
		DefaultCategoryDataset result = new DefaultCategoryDataset();
		if(u!=null && u.getEs() != null)
			for (int i = 0; i < u.getEs().size(); i++){
				result.addValue(u.getEssay(i).getBad(), "Incorrectas", "Ensayo"+u.getEssay(i).getNumber());
				result.addValue(u.getEssay(i).getOmitted(), "Omitidas", "Ensayo"+u.getEssay(i).getNumber());
				result.addValue(u.getEssay(i).getGood(), "Correctas", "Ensayo"+u.getEssay(i).getNumber());
			}
		return result;
	}

	private JFreeChart createChart(final CategoryDataset dataset, userHandler u) throws Exception {
		 final CategoryDataset dataset2 = createDataset(u);
	        final NumberAxis rangeAxis2 = new NumberAxis("Preguntas");
	        rangeAxis2.setStandardTickUnits(NumberAxis.createIntegerTickUnits());
	        final BarRenderer render = new BarRenderer();
	        render.setBaseToolTipGenerator(new StandardCategoryToolTipGenerator());
	        render.setBaseItemLabelGenerator(new StandardCategoryItemLabelGenerator(
					   "{2}", NumberFormat.getInstance())); 
	        render.setBaseToolTipGenerator(new StandardCategoryToolTipGenerator(
					   "{3} de respuestas {0} en {1}", 
					   NumberFormat.getInstance()));
	        render.setBaseItemLabelsVisible(true);
	        final CategoryPlot subplot = new CategoryPlot(dataset2, null, rangeAxis2, render);
	        subplot.setDomainGridlinesVisible(true);

	        final CategoryAxis domainAxis = new CategoryAxis();
	        final CombinedDomainCategoryPlot plot = new CombinedDomainCategoryPlot(domainAxis);
	        plot.add(subplot);
	        
	        final JFreeChart result = new JFreeChart(
	            "Respuestas",
	            null,
	            plot,
	            true
	        );
	    return result;
	}
}

class PanelPuntajes extends JPanel {
	private static final long serialVersionUID = 1L;
	public PanelPuntajes(userHandler u) {
        JLabel jLabel1 = new JLabel();
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/header2.png")));
        final ChartPanel chartPanel = new ChartPanel(createChart(u));
        //chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
        setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS)); //BoxLayout permite resize del panel
		add(jLabel1);
        add(chartPanel);
    }
    /**
     * Creates a dataset.
     *
     * @return A dataset.
     */
    public CategoryDataset createDataset1(userHandler u) {

        final DefaultCategoryDataset result = new DefaultCategoryDataset();

        // row keys...
        final String series1 = "First";
        if(u!=null && u.getEs()!=null) {
	        for (int i = 0; i < u.getEs().size(); i++){
				result.addValue(10*(u.getEssay(i).getGood()-u.getEssay(i).getBad()/4)+100, series1, "Ensayo"+u.getEssay(i).getNumber());
			}
        }
        return result;
    }
    
    /**
     * Creates a chart.
     *
     * @return A chart.
     */
    private JFreeChart createChart(userHandler u) {

        final CategoryDataset dataset1 = createDataset1(u);
        final NumberAxis rangeAxis1 = new NumberAxis("Puntaje");
        rangeAxis1.setStandardTickUnits(NumberAxis.createIntegerTickUnits());
        final LineAndShapeRenderer render = new LineAndShapeRenderer();
        render.setBaseItemLabelGenerator(new StandardCategoryItemLabelGenerator(
				   "{2}", NumberFormat.getInstance())); 
        render.setBaseToolTipGenerator(new StandardCategoryToolTipGenerator(
				   "{2} puntos en {1}", 
				   NumberFormat.getInstance()));
        render.setBaseItemLabelsVisible(true);
        final CategoryPlot subplot1 = new CategoryPlot(dataset1, null, rangeAxis1, render);
        subplot1.setDomainGridlinesVisible(true);

        final CategoryAxis domainAxis = new CategoryAxis();
        final CombinedDomainCategoryPlot plot = new CombinedDomainCategoryPlot(domainAxis);
        plot.add(subplot1);
        
        final JFreeChart result = new JFreeChart(
            "Puntajes",
            null,
            plot,
            false
        );
        return result;

    }
}